/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.biojava.ontology.format.triples.parser;

import org.biojava.ontology.format.triples.lexer.*;
import org.biojava.ontology.format.triples.node.*;
import org.biojava.ontology.format.triples.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int numstate, ArrayList listNode) throws ParserException, LexerException, IOException
    {
	this.nodeList = listNode;

        if(!stack.hasNext())
        {
            stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
        return (ArrayList) ((State) stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(lexer.next());
                        push(action[1], list);
                        last_shift = action[1];
                    }
		    break;
                case REDUCE:
                    switch(action[1])
                    {

                    case 0:
		    {
			ArrayList list = new0();
			push(goTo(0), list);
		    }
		    break;


                    case 1:
		    {
			ArrayList list = new1();
			push(goTo(0), list);
		    }
		    break;


                    case 2:
		    {
			ArrayList list = new2();
			push(goTo(0), list);
		    }
		    break;


                    case 3:
		    {
			ArrayList list = new3();
			push(goTo(0), list);
		    }
		    break;


                    case 4:
		    {
			ArrayList list = new4();
			push(goTo(1), list);
		    }
		    break;


                    case 5:
		    {
			ArrayList list = new5();
			push(goTo(1), list);
		    }
		    break;


                    case 6:
		    {
			ArrayList list = new6();
			push(goTo(2), list);
		    }
		    break;


                    case 7:
		    {
			ArrayList list = new7();
			push(goTo(3), list);
		    }
		    break;


                    case 8:
		    {
			ArrayList list = new8();
			push(goTo(3), list);
		    }
		    break;


                    case 9:
		    {
			ArrayList list = new9();
			push(goTo(4), list);
		    }
		    break;


                    case 10:
		    {
			ArrayList list = new10();
			push(goTo(5), list);
		    }
		    break;


                    case 11:
		    {
			ArrayList list = new11();
			push(goTo(5), list);
		    }
		    break;


                    case 12:
		    {
			ArrayList list = new12();
			push(goTo(5), list);
		    }
		    break;


                    case 13:
		    {
			ArrayList list = new13();
			push(goTo(5), list);
		    }
		    break;


                    case 14:
		    {
			ArrayList list = new14();
			push(goTo(5), list);
		    }
		    break;


                    case 15:
		    {
			ArrayList list = new15();
			push(goTo(5), list);
		    }
		    break;


                    case 16:
		    {
			ArrayList list = new16();
			push(goTo(5), list);
		    }
		    break;


                    case 17:
		    {
			ArrayList list = new17();
			push(goTo(5), list);
		    }
		    break;


                    case 18:
		    {
			ArrayList list = new18();
			push(goTo(5), list);
		    }
		    break;


                    case 19:
		    {
			ArrayList list = new19();
			push(goTo(5), list);
		    }
		    break;


                    case 20:
		    {
			ArrayList list = new20();
			push(goTo(5), list);
		    }
		    break;


                    case 21:
		    {
			ArrayList list = new21();
			push(goTo(5), list);
		    }
		    break;


                    case 22:
		    {
			ArrayList list = new22();
			push(goTo(5), list);
		    }
		    break;


                    case 23:
		    {
			ArrayList list = new23();
			push(goTo(6), list);
		    }
		    break;


                    case 24:
		    {
			ArrayList list = new24();
			push(goTo(6), list);
		    }
		    break;


                    case 25:
		    {
			ArrayList list = new25();
			push(goTo(7), list);
		    }
		    break;


                    case 26:
		    {
			ArrayList list = new26();
			push(goTo(7), list);
		    }
		    break;


                    case 27:
		    {
			ArrayList list = new27();
			push(goTo(8), list);
		    }
		    break;


                    case 28:
		    {
			ArrayList list = new28();
			push(goTo(8), list);
		    }
		    break;


                    case 29:
		    {
			ArrayList list = new29();
			push(goTo(9), list);
		    }
		    break;


                    case 30:
		    {
			ArrayList list = new30();
			push(goTo(10), list);
		    }
		    break;


                    case 31:
		    {
			ArrayList list = new31();
			push(goTo(11), list);
		    }
		    break;


                    case 32:
		    {
			ArrayList list = new32();
			push(goTo(12), list);
		    }
		    break;


                    case 33:
		    {
			ArrayList list = new33();
			push(goTo(12), list);
		    }
		    break;


                    case 34:
		    {
			ArrayList list = new34();
			push(goTo(13), list);
		    }
		    break;


                    case 35:
		    {
			ArrayList list = new35();
			push(goTo(13), list);
		    }
		    break;

                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PProgram node1 = (PProgram) ((ArrayList)pop()).get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }



    ArrayList new0()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PProgram pprogramNode1;
        {
        PNamespaceDecl pnamespacedeclNode2;
        TypedLinkedList listNode3 = new TypedLinkedList();
        TypedLinkedList listNode4 = new TypedLinkedList();
        pnamespacedeclNode2 = (PNamespaceDecl)nodeArrayList1.get(0);
        {
        }
        {
        }

        pprogramNode1 = new AProgram(pnamespacedeclNode2, listNode3, listNode4);
        }
	nodeList.add(pprogramNode1);
        return nodeList;
    }



    ArrayList new1()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PProgram pprogramNode1;
        {
        PNamespaceDecl pnamespacedeclNode2;
        TypedLinkedList listNode4 = new TypedLinkedList();
        TypedLinkedList listNode5 = new TypedLinkedList();
        pnamespacedeclNode2 = (PNamespaceDecl)nodeArrayList1.get(0);
        {
        TypedLinkedList listNode3 = new TypedLinkedList();
        listNode3 = (TypedLinkedList)nodeArrayList2.get(0);
	if(listNode3 != null)
	{
	  listNode4.addAll(listNode3);
	}
        }
        {
        }

        pprogramNode1 = new AProgram(pnamespacedeclNode2, listNode4, listNode5);
        }
	nodeList.add(pprogramNode1);
        return nodeList;
    }



    ArrayList new2()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PProgram pprogramNode1;
        {
        PNamespaceDecl pnamespacedeclNode2;
        TypedLinkedList listNode3 = new TypedLinkedList();
        TypedLinkedList listNode5 = new TypedLinkedList();
        pnamespacedeclNode2 = (PNamespaceDecl)nodeArrayList1.get(0);
        {
        }
        {
        TypedLinkedList listNode4 = new TypedLinkedList();
        listNode4 = (TypedLinkedList)nodeArrayList2.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }

        pprogramNode1 = new AProgram(pnamespacedeclNode2, listNode3, listNode5);
        }
	nodeList.add(pprogramNode1);
        return nodeList;
    }



    ArrayList new3()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PProgram pprogramNode1;
        {
        PNamespaceDecl pnamespacedeclNode2;
        TypedLinkedList listNode4 = new TypedLinkedList();
        TypedLinkedList listNode6 = new TypedLinkedList();
        pnamespacedeclNode2 = (PNamespaceDecl)nodeArrayList1.get(0);
        {
        TypedLinkedList listNode3 = new TypedLinkedList();
        listNode3 = (TypedLinkedList)nodeArrayList2.get(0);
	if(listNode3 != null)
	{
	  listNode4.addAll(listNode3);
	}
        }
        {
        TypedLinkedList listNode5 = new TypedLinkedList();
        listNode5 = (TypedLinkedList)nodeArrayList3.get(0);
	if(listNode5 != null)
	{
	  listNode6.addAll(listNode5);
	}
        }

        pprogramNode1 = new AProgram(pnamespacedeclNode2, listNode4, listNode6);
        }
	nodeList.add(pprogramNode1);
        return nodeList;
    }



    ArrayList new4()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PNamespaceDecl pnamespacedeclNode1;
        {
        TNamespace tnamespaceNode2;
        PFullName pfullnameNode3;
        Object nullNode4 = null;
        tnamespaceNode2 = (TNamespace)nodeArrayList1.get(0);
        pfullnameNode3 = (PFullName)nodeArrayList2.get(0);

        pnamespacedeclNode1 = new ANamespaceDecl(tnamespaceNode2, pfullnameNode3, null);
        }
	nodeList.add(pnamespacedeclNode1);
        return nodeList;
    }



    ArrayList new5()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PNamespaceDecl pnamespacedeclNode1;
        {
        TNamespace tnamespaceNode2;
        PFullName pfullnameNode3;
        TComment tcommentNode4;
        tnamespaceNode2 = (TNamespace)nodeArrayList1.get(0);
        pfullnameNode3 = (PFullName)nodeArrayList2.get(0);
        tcommentNode4 = (TComment)nodeArrayList3.get(0);

        pnamespacedeclNode1 = new ANamespaceDecl(tnamespaceNode2, pfullnameNode3, tcommentNode4);
        }
	nodeList.add(pnamespacedeclNode1);
        return nodeList;
    }



    ArrayList new6()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PImportExpr pimportexprNode1;
        {
        TImport timportNode2;
        PFullName pfullnameNode3;
        TAs tasNode4;
        TName tnameNode5;
        timportNode2 = (TImport)nodeArrayList1.get(0);
        pfullnameNode3 = (PFullName)nodeArrayList2.get(0);
        tasNode4 = (TAs)nodeArrayList3.get(0);
        tnameNode5 = (TName)nodeArrayList4.get(0);

        pimportexprNode1 = new AImportExpr(timportNode2, pfullnameNode3, tasNode4, tnameNode5);
        }
	nodeList.add(pimportexprNode1);
        return nodeList;
    }



    ArrayList new7()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpressionDecl pexpressiondeclNode1;
        {
        Object nullNode2 = null;
        PExpression pexpressionNode3;
        pexpressionNode3 = (PExpression)nodeArrayList1.get(0);

        pexpressiondeclNode1 = new AExpressionDecl(null, pexpressionNode3);
        }
	nodeList.add(pexpressiondeclNode1);
        return nodeList;
    }



    ArrayList new8()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpressionDecl pexpressiondeclNode1;
        {
        PExpressionName pexpressionnameNode2;
        PExpression pexpressionNode3;
        pexpressionnameNode2 = (PExpressionName)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);

        pexpressiondeclNode1 = new AExpressionDecl(pexpressionnameNode2, pexpressionNode3);
        }
	nodeList.add(pexpressiondeclNode1);
        return nodeList;
    }



    ArrayList new9()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpressionName pexpressionnameNode1;
        {
        TName tnameNode2;
        TAs tasNode3;
        tnameNode2 = (TName)nodeArrayList1.get(0);
        tasNode3 = (TAs)nodeArrayList2.get(0);

        pexpressionnameNode1 = new AExpressionName(tnameNode2, tasNode3);
        }
	nodeList.add(pexpressionnameNode1);
        return nodeList;
    }



    ArrayList new10()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList6 = (ArrayList) pop();
        ArrayList nodeArrayList5 = (ArrayList) pop();
        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PPredicate ppredicateNode2;
        Object nullNode4 = null;
        TLeftElipse tleftelipseNode5;
        PExpression pexpressionNode6;
        TComma tcommaNode7;
        PExpression pexpressionNode8;
        TRightElipse trightelipseNode9;
        {
        PFullName pfullnameNode3;
        pfullnameNode3 = (PFullName)nodeArrayList1.get(0);

        ppredicateNode2 = new ANamePredicate(pfullnameNode3);
        }
        tleftelipseNode5 = (TLeftElipse)nodeArrayList2.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList3.get(0);
        tcommaNode7 = (TComma)nodeArrayList4.get(0);
        pexpressionNode8 = (PExpression)nodeArrayList5.get(0);
        trightelipseNode9 = (TRightElipse)nodeArrayList6.get(0);

        pexpressionNode1 = new AComplexExpression(ppredicateNode2, null, tleftelipseNode5, pexpressionNode6, tcommaNode7, pexpressionNode8, trightelipseNode9);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new11()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList6 = (ArrayList) pop();
        ArrayList nodeArrayList5 = (ArrayList) pop();
        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PPredicate ppredicateNode2;
        Object nullNode4 = null;
        TLeftElipse tleftelipseNode5;
        PExpression pexpressionNode6;
        TComma tcommaNode7;
        PExpression pexpressionNode8;
        TRightElipse trightelipseNode9;
        {
        TVariable tvariableNode3;
        tvariableNode3 = (TVariable)nodeArrayList1.get(0);

        ppredicateNode2 = new AVariablePredicate(tvariableNode3);
        }
        tleftelipseNode5 = (TLeftElipse)nodeArrayList2.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList3.get(0);
        tcommaNode7 = (TComma)nodeArrayList4.get(0);
        pexpressionNode8 = (PExpression)nodeArrayList5.get(0);
        trightelipseNode9 = (TRightElipse)nodeArrayList6.get(0);

        pexpressionNode1 = new AComplexExpression(ppredicateNode2, null, tleftelipseNode5, pexpressionNode6, tcommaNode7, pexpressionNode8, trightelipseNode9);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new12()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList7 = (ArrayList) pop();
        ArrayList nodeArrayList6 = (ArrayList) pop();
        ArrayList nodeArrayList5 = (ArrayList) pop();
        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PPredicate ppredicateNode2;
        TComment tcommentNode4;
        TLeftElipse tleftelipseNode5;
        PExpression pexpressionNode6;
        TComma tcommaNode7;
        PExpression pexpressionNode8;
        TRightElipse trightelipseNode9;
        {
        PFullName pfullnameNode3;
        pfullnameNode3 = (PFullName)nodeArrayList1.get(0);

        ppredicateNode2 = new ANamePredicate(pfullnameNode3);
        }
        tcommentNode4 = (TComment)nodeArrayList2.get(0);
        tleftelipseNode5 = (TLeftElipse)nodeArrayList3.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList4.get(0);
        tcommaNode7 = (TComma)nodeArrayList5.get(0);
        pexpressionNode8 = (PExpression)nodeArrayList6.get(0);
        trightelipseNode9 = (TRightElipse)nodeArrayList7.get(0);

        pexpressionNode1 = new AComplexExpression(ppredicateNode2, tcommentNode4, tleftelipseNode5, pexpressionNode6, tcommaNode7, pexpressionNode8, trightelipseNode9);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new13()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList7 = (ArrayList) pop();
        ArrayList nodeArrayList6 = (ArrayList) pop();
        ArrayList nodeArrayList5 = (ArrayList) pop();
        ArrayList nodeArrayList4 = (ArrayList) pop();
        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PPredicate ppredicateNode2;
        TComment tcommentNode4;
        TLeftElipse tleftelipseNode5;
        PExpression pexpressionNode6;
        TComma tcommaNode7;
        PExpression pexpressionNode8;
        TRightElipse trightelipseNode9;
        {
        TVariable tvariableNode3;
        tvariableNode3 = (TVariable)nodeArrayList1.get(0);

        ppredicateNode2 = new AVariablePredicate(tvariableNode3);
        }
        tcommentNode4 = (TComment)nodeArrayList2.get(0);
        tleftelipseNode5 = (TLeftElipse)nodeArrayList3.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList4.get(0);
        tcommaNode7 = (TComma)nodeArrayList5.get(0);
        pexpressionNode8 = (PExpression)nodeArrayList6.get(0);
        trightelipseNode9 = (TRightElipse)nodeArrayList7.get(0);

        pexpressionNode1 = new AComplexExpression(ppredicateNode2, tcommentNode4, tleftelipseNode5, pexpressionNode6, tcommaNode7, pexpressionNode8, trightelipseNode9);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new14()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PList plistNode2;
        plistNode2 = (PList)nodeArrayList1.get(0);

        pexpressionNode1 = new AListExpression(plistNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new15()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        Object nullNode4 = null;
        {
        PFullName pfullnameNode3;
        pfullnameNode3 = (PFullName)nodeArrayList1.get(0);

        pvalueNode2 = new ANameValue(pfullnameNode3);
        }

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, null);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new16()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        Object nullNode4 = null;
        {
        TVariable tvariableNode3;
        tvariableNode3 = (TVariable)nodeArrayList1.get(0);

        pvalueNode2 = new AVariableValue(tvariableNode3);
        }

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, null);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new17()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        Object nullNode4 = null;
        {
        PIntegerLiteral pintegerliteralNode3;
        pintegerliteralNode3 = (PIntegerLiteral)nodeArrayList1.get(0);

        pvalueNode2 = new AIntegerLiteralValue(pintegerliteralNode3);
        }

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, null);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new18()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        Object nullNode4 = null;
        {
        PStringLiteral pstringliteralNode3;
        pstringliteralNode3 = (PStringLiteral)nodeArrayList1.get(0);

        pvalueNode2 = new AStringLiteralValue(pstringliteralNode3);
        }

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, null);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new19()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TComment tcommentNode4;
        {
        PFullName pfullnameNode3;
        pfullnameNode3 = (PFullName)nodeArrayList1.get(0);

        pvalueNode2 = new ANameValue(pfullnameNode3);
        }
        tcommentNode4 = (TComment)nodeArrayList2.get(0);

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, tcommentNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new20()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TComment tcommentNode4;
        {
        TVariable tvariableNode3;
        tvariableNode3 = (TVariable)nodeArrayList1.get(0);

        pvalueNode2 = new AVariableValue(tvariableNode3);
        }
        tcommentNode4 = (TComment)nodeArrayList2.get(0);

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, tcommentNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new21()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TComment tcommentNode4;
        {
        PIntegerLiteral pintegerliteralNode3;
        pintegerliteralNode3 = (PIntegerLiteral)nodeArrayList1.get(0);

        pvalueNode2 = new AIntegerLiteralValue(pintegerliteralNode3);
        }
        tcommentNode4 = (TComment)nodeArrayList2.get(0);

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, tcommentNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new22()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PExpression pexpressionNode1;
        {
        PValue pvalueNode2;
        TComment tcommentNode4;
        {
        PStringLiteral pstringliteralNode3;
        pstringliteralNode3 = (PStringLiteral)nodeArrayList1.get(0);

        pvalueNode2 = new AStringLiteralValue(pstringliteralNode3);
        }
        tcommentNode4 = (TComment)nodeArrayList2.get(0);

        pexpressionNode1 = new ASimpleExpression(pvalueNode2, tcommentNode4);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    ArrayList new23()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PFullName pfullnameNode1;
        {
        TName tnameNode2;
        tnameNode2 = (TName)nodeArrayList1.get(0);

        pfullnameNode1 = new ASimpleFullName(tnameNode2);
        }
	nodeList.add(pfullnameNode1);
        return nodeList;
    }



    ArrayList new24()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PFullName pfullnameNode1;
        {
        TName tnameNode2;
        TDot tdotNode3;
        PFullName pfullnameNode4;
        tnameNode2 = (TName)nodeArrayList1.get(0);
        tdotNode3 = (TDot)nodeArrayList2.get(0);
        pfullnameNode4 = (PFullName)nodeArrayList3.get(0);

        pfullnameNode1 = new ACompoundFullName(tnameNode2, tdotNode3, pfullnameNode4);
        }
	nodeList.add(pfullnameNode1);
        return nodeList;
    }



    ArrayList new25()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PList plistNode1;
        {
        TLeftSquare tleftsquareNode2;
        TRightSquare trightsquareNode3;
        tleftsquareNode2 = (TLeftSquare)nodeArrayList1.get(0);
        trightsquareNode3 = (TRightSquare)nodeArrayList2.get(0);

        plistNode1 = new AEmptyList(tleftsquareNode2, trightsquareNode3);
        }
	nodeList.add(plistNode1);
        return nodeList;
    }



    ArrayList new26()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList3 = (ArrayList) pop();
        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PList plistNode1;
        {
        TLeftSquare tleftsquareNode2;
        PListBody plistbodyNode3;
        TRightSquare trightsquareNode4;
        tleftsquareNode2 = (TLeftSquare)nodeArrayList1.get(0);
        plistbodyNode3 = (PListBody)nodeArrayList2.get(0);
        trightsquareNode4 = (TRightSquare)nodeArrayList3.get(0);

        plistNode1 = new AFullList(tleftsquareNode2, plistbodyNode3, trightsquareNode4);
        }
	nodeList.add(plistNode1);
        return nodeList;
    }



    ArrayList new27()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PListBody plistbodyNode1;
        {
        PExpression pexpressionNode2;
        Object nullNode3 = null;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);

        plistbodyNode1 = new AListBody(pexpressionNode2, null);
        }
	nodeList.add(plistbodyNode1);
        return nodeList;
    }



    ArrayList new28()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PListBody plistbodyNode1;
        {
        PExpression pexpressionNode2;
        PListTail plisttailNode3;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);
        plisttailNode3 = (PListTail)nodeArrayList2.get(0);

        plistbodyNode1 = new AListBody(pexpressionNode2, plisttailNode3);
        }
	nodeList.add(plistbodyNode1);
        return nodeList;
    }



    ArrayList new29()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        PListTail plisttailNode1;
        {
        TComma tcommaNode2;
        PListBody plistbodyNode3;
        tcommaNode2 = (TComma)nodeArrayList1.get(0);
        plistbodyNode3 = (PListBody)nodeArrayList2.get(0);

        plisttailNode1 = new AListTail(tcommaNode2, plistbodyNode3);
        }
	nodeList.add(plisttailNode1);
        return nodeList;
    }



    ArrayList new30()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PIntegerLiteral pintegerliteralNode1;
        {
        TNumber tnumberNode2;
        tnumberNode2 = (TNumber)nodeArrayList1.get(0);

        pintegerliteralNode1 = new AIntegerLiteral(tnumberNode2);
        }
	nodeList.add(pintegerliteralNode1);
        return nodeList;
    }



    ArrayList new31()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        PStringLiteral pstringliteralNode1;
        {
        TQuotedString tquotedstringNode2;
        tquotedstringNode2 = (TQuotedString)nodeArrayList1.get(0);

        pstringliteralNode1 = new AStringLiteral(tquotedstringNode2);
        }
	nodeList.add(pstringliteralNode1);
        return nodeList;
    }



    ArrayList new32()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        TypedLinkedList listNode2 = new TypedLinkedList();
        {
        PImportExpr pimportexprNode1;
        pimportexprNode1 = (PImportExpr)nodeArrayList1.get(0);
	if(pimportexprNode1 != null)
	{
	  listNode2.add(pimportexprNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    ArrayList new33()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        TypedLinkedList listNode3 = new TypedLinkedList();
        {
        TypedLinkedList listNode1 = new TypedLinkedList();
        PImportExpr pimportexprNode2;
        listNode1 = (TypedLinkedList)nodeArrayList1.get(0);
        pimportexprNode2 = (PImportExpr)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pimportexprNode2 != null)
	{
	  listNode3.add(pimportexprNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    ArrayList new34()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList1 = (ArrayList) pop();
        TypedLinkedList listNode2 = new TypedLinkedList();
        {
        PExpressionDecl pexpressiondeclNode1;
        pexpressiondeclNode1 = (PExpressionDecl)nodeArrayList1.get(0);
	if(pexpressiondeclNode1 != null)
	{
	  listNode2.add(pexpressiondeclNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    ArrayList new35()
    {
        ArrayList nodeList = new ArrayList();

        ArrayList nodeArrayList2 = (ArrayList) pop();
        ArrayList nodeArrayList1 = (ArrayList) pop();
        TypedLinkedList listNode3 = new TypedLinkedList();
        {
        TypedLinkedList listNode1 = new TypedLinkedList();
        PExpressionDecl pexpressiondeclNode2;
        listNode1 = (TypedLinkedList)nodeArrayList1.get(0);
        pexpressiondeclNode2 = (PExpressionDecl)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pexpressiondeclNode2 != null)
	{
	  listNode3.add(pexpressiondeclNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, },
			{{-1, ERROR, 1}, {11, SHIFT, 4}, },
			{{-1, ERROR, 2}, {16, ACCEPT, -1}, },
			{{-1, REDUCE, 0}, {1, SHIFT, 6}, {7, SHIFT, 7}, {11, SHIFT, 8}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 23}, {10, SHIFT, 22}, },
			{{-1, REDUCE, 4}, {14, SHIFT, 23}, },
			{{-1, ERROR, 6}, {11, SHIFT, 4}, },
			{{-1, ERROR, 7}, {7, SHIFT, 7}, {8, SHIFT, 25}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 23}, {2, SHIFT, 28}, {10, SHIFT, 22}, },
			{{-1, REDUCE, 16}, {3, SHIFT, 29}, {14, SHIFT, 30}, },
			{{-1, REDUCE, 30}, },
			{{-1, REDUCE, 31}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 14}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 15}, {3, SHIFT, 32}, {14, SHIFT, 33}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 17}, {14, SHIFT, 34}, },
			{{-1, REDUCE, 18}, {14, SHIFT, 35}, },
			{{-1, REDUCE, 1}, {1, SHIFT, 6}, {7, SHIFT, 7}, {11, SHIFT, 8}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 2}, {7, SHIFT, 7}, {11, SHIFT, 8}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, ERROR, 22}, {11, SHIFT, 4}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 24}, {2, SHIFT, 40}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 27}, {9, SHIFT, 41}, },
			{{-1, ERROR, 27}, {8, SHIFT, 43}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 29}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 20}, {3, SHIFT, 45}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 32}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 19}, {3, SHIFT, 47}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 33}, },
			{{-1, REDUCE, 3}, {7, SHIFT, 7}, {11, SHIFT, 8}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 40}, {11, SHIFT, 48}, },
			{{-1, ERROR, 41}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 44}, {9, SHIFT, 50}, },
			{{-1, ERROR, 45}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, ERROR, 46}, {9, SHIFT, 52}, },
			{{-1, ERROR, 47}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 29}, },
			{{-1, ERROR, 50}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, ERROR, 51}, {9, SHIFT, 55}, },
			{{-1, ERROR, 52}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, ERROR, 53}, {9, SHIFT, 57}, },
			{{-1, ERROR, 54}, {4, SHIFT, 58}, },
			{{-1, ERROR, 55}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, ERROR, 56}, {4, SHIFT, 60}, },
			{{-1, ERROR, 57}, {7, SHIFT, 7}, {11, SHIFT, 4}, {12, SHIFT, 9}, {13, SHIFT, 10}, {15, SHIFT, 11}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 59}, {4, SHIFT, 62}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 61}, {4, SHIFT, 63}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 12}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 2}, },
			{{-1, 3}, },
			{{-1, 12}, {20, 36}, },
			{{-1, 13}, {21, 38}, {37, 38}, },
			{{-1, 14}, },
			{{-1, 15}, {7, 26}, {14, 31}, {29, 44}, {32, 46}, {41, 26}, {45, 51}, {47, 53}, {50, 54}, {52, 56}, {55, 59}, {57, 61}, },
			{{-1, 16}, {1, 5}, {6, 24}, {22, 39}, },
			{{-1, 17}, },
			{{-1, 27}, {41, 49}, },
			{{-1, 42}, },
			{{-1, 18}, },
			{{-1, 19}, },
			{{-1, 20}, },
			{{-1, 21}, {20, 37}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'namespace'",
			"expecting: name",
			"expecting: EOF",
			"expecting: 'import', '[', name, variable, number, quoted string, EOF",
			"expecting: 'import', 'as', '(', ')', '[', ']', ',', '.', name, variable, number, comment, quoted string, EOF",
			"expecting: 'import', '[', name, variable, number, comment, quoted string, EOF",
			"expecting: '[', ']', name, variable, number, quoted string",
			"expecting: 'as', '(', '[', '.', name, variable, number, comment, quoted string, EOF",
			"expecting: '(', ')', '[', ']', ',', name, variable, number, comment, quoted string, EOF",
			"expecting: ')', '[', ']', ',', name, variable, number, comment, quoted string, EOF",
			"expecting: '[', name, variable, number, quoted string, EOF",
			"expecting: '[', name, variable, number, quoted string",
			"expecting: ')', '[', ']', ',', name, variable, number, quoted string, EOF",
			"expecting: 'as'",
			"expecting: ']', ','",
			"expecting: ']'",
			"expecting: '(', ')', '[', ']', ',', name, variable, number, quoted string, EOF",
			"expecting: 'import', 'as', '(', ')', '[', ']', ',', name, variable, number, comment, quoted string, EOF",
			"expecting: ','",
			"expecting: ')'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 4, 5, 1, 6, 7, 8, 9, 9, 3, 10, 11, 10, 8, 12, 9, 9, 3, 10, 1, 3, 13, 12, 14, 15, 11, 11, 16, 10, 11, 16, 12, 12, 3, 10, 10, 17, 1, 11, 15, 12, 18, 11, 18, 11, 3, 15, 11, 18, 11, 18, 19, 11, 19, 11, 12, 19, 12, 19, 12, 12, 
        };*/
}
